"""ISN Additionneur binaire"""

N = 16 #variable globale nombre de bits sur lequel on travaille


##Q1

def addition1bit(a, b):
    """Retourne le bit de retenue et le bit d'unité
    de l'addition de deux entiers codés sur 1 bit"""
    unite = (a+b)%2
    retenue = (a+b)//2
    return retenue, unite

def test1():
    """Fonction de test de l'additionneur sur 1 bit"""
    for a in range(0, 2):
        for b in range(0, 2):
            retenue, unite = addition1bit(a, b)
            print(a, '+', b, '=', str(retenue)+str(unite))
        
"""

In [2]: test1()
0 + 0 = 00
0 + 1 = 01
1 + 0 = 01
1 + 1 = 10
"""
##Q2

def addition1bitbis(a, b, retenue):
    """Retourne le bit de retenue et le bit d'unité
    de l'addition de deux entiers codés sur 1 bit avec retenue entrante"""
    unite = (a+b+retenue)%2
    retenue = (a+b+retenue)//2
    return retenue, unite

"""
In [7]: c = [1,1]

In [8]: d = [0, 1]

In [9]: retenue, unite = addition1bit(a[1], b[1])

In [10]: retenue, unite
Out[10]: (1, 0)

In [11]: int('11', 2) + int('01', 2)
Out[11]: 4

In [12]: retenue, deuzaine = addition1bitbis(a[0], b[0], retenue)

In [13]: retenue, deuzaine
Out[13]: (1, 0)
"""

##Q3


def binaire(n):
    """liste des bits (max N) de n"""
    t = [0]*N
    k = N - 1
    while n != 0 and k>=0:
        t[k] =  n%2
        n = n // 2
        k -= 1
    return t
     
"""
In [5]: [binaire(i) for i in range(17)]
Out[5]: 
[[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1],
 [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0]]
"""

##Q4

def decimale(t):
    """inverse de la précédente"""
    n = 0
    k = 0
    for bit in t[::-1]:
        n += bit*2**k
        k += 1
    return n

"""
In [6]: [decimale(binaire(i)) for i in range(17)]
Out[6]: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]
"""

##Q5

def addition_listes(L, M):
    retenue = 0
    S = [0]*N
    for i in range(N-1, -1, -1):
        S[i] = (L[i] + M[i] + retenue)%2
        retenue = (L[i] + M[i] + retenue)//2
    return S


##Q6

def addition(p, q):
    return addition_listes(binaire(p), binaire(q))


"""
In [10]: decimale(addition(4,5))
Out[10]: 9

"""

"""
Exemple de dépassement de capacité


In [26]: addition(2**16-1,1)
Out[26]: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

"""
